<template>
  <div class="contact-container" @click="addToGroup">
    <img
      :src="profileUrl"
      alt="image"
      class="avatar-image"
      loading="lazy"
      v-if="profileUrl"
    />
    <div v-else>
      <div class="fristchar" :class="[item.avatarClass]" v-if="item.name">
        {{ item.name.slice(0, 1).toUpperCase() }}
      </div>
      <div class="fristchar" :class="[item.avatarClass]" v-else>
        {{ item.nickname.slice(0, 1).toUpperCase() }}
      </div>
    </div>

    <div class="check-container" v-if="memberInGroup">
      <img src="/Images/tabs/green-check.svg" alt="icon" />
    </div>

    <div class="content">
      <div class="user-information">
        <div class="user-information-title">
          {{ item.name }}
        </div>

        <div class="time">
          <span v-if="item.lastSeen && item.lastSeen == 'yesterday'">{{
            $t('tabs.contacts.lastSeen', { time: t('tabs.contacts.yesterday') })
          }}</span>

          <span v-if="item.lastSeen && item.lastSeen != 'yesterday'">
            {{ $t('tabs.contacts.lastSeen', { time: item.lastSeen }) }}
          </span>
        </div>
      </div>
    </div>
  </div>
</template>

<script setup>
import { getFile } from '@/helpers/parser.js';
import { useUserStore } from '@/store/user/user.js';
import { computed, defineProps } from 'vue';
import { useI18n } from 'vue-i18n';
import { proxyParser } from '@/helpers/parser';
import { useContactsStore } from '@/store/contacts/contacts.js';
import { useOverallChatsStore } from '@/store/chats/overall.js';
import { ref, onMounted } from 'vue';

const { t, locale } = useI18n();
const profileUrl = ref('');
const dir = ref('ltr');
const userStore = useUserStore();

const overallChatsStore = useOverallChatsStore();

const props = defineProps({
  item: {
    type: Object,
  },
});

const addToGroup = () => {
  const member = { blob: profileUrl.value, ...props.item };
  overallChatsStore.addMemberToGroup(member);
};

const memberInGroup = computed(() => {
  const membersID = overallChatsStore.groupMembersClient
    .map((member) => member.id)
    .includes(props.item.id);
  return membersID;
});

onMounted(async () => {
  const contactStore = useContactsStore();
  const info = await contactStore.getContactInformation(
    props.item.contact_username,
  );
  if (info.avatar) {
    const fileId = info.avatar.split('.');
    const fileIdResult = fileId[0] ? fileId[0] : info.avatar;
    const blob = await getFile(fileIdResult, userStore.token, 'image');
    profileUrl.value = blob.filePath;
  }
  if (locale.value === 'fa') {
    dir.value = 'rtl';
  }
});
</script>

<style scoped>
.check-container {
  width: 25px;
  height: 22px;
  border-radius: 50%;
  background: #3fdd3c;
  display: flex;
  justify-content: center;
  align-items: center;
  position: absolute;
  z-index: 100;
  margin-top: 35px;
  margin-right: 22px;
}
.contact-container {
  padding: 5px 2px;
  display: flex;
  align-items: center;
  justify-content: flex-start;
  position: relative;
}
.fristchar {
  width: 50px;
  height: 50px;
  display: flex;
  justify-content: center;
  align-items: center;
  border-radius: 50%;
  color: #fff;
  font-size: 32px;
  font-weight: 500;
}
.content {
  display: flex;
  align-items: center;
  justify-content: space-between;
  gap: 10px;
  font-size: 20px;
  font-weight: 600;
  padding: 0px 10px;
}
.avatar-image {
  width: 50px;
  height: 50px;
  border-radius: 50%;
}
.avatar-image-loaded {
  opacity: 1;
}
.avatar-image-loaded-without-anim {
  opacity: 1;
}
.user-information-title {
  direction: ltr;
  text-overflow: ellipsis;
  white-space: nowrap;
  overflow: hidden;
  width: 45vw;
}
.font-farsi .user-information-title {
  text-align: right;
}
.time {
  font-size: 12px;
  color: var(--ion-color-medium);
  min-height: 20px;
}
.hidden-char {
  /* opacity: 0; */
  transform: scale(0);
}
.firstchar-container {
  font-weight: bold;
  font-size: calc(30px - 1vmin);
  background-color: aqua;
}
</style>
